%define module amdgpu
%define modsrc %{buildroot}/usr/src/%{module}-%{version}-%{release}/amd/dkms
%define dracutd %{_sysconfdir}/dracut.conf.d
%define force %{_datadir}/dkms/modules_to_force_install

Summary: The amdgpu Linux kernel driver
Name: amdgpu-dkms
Version: 5.6.0.13
Release: 1089974.el8
Epoch: 1
Group: System Environment/Kernel
License: GPLv2 and Redistributable, no modification permitted
BuildArch: noarch
URL: http://www.amd.com/
Source1: rbh.sh
Source2: rbh.conf
Source100: dkms.rbh
Source101: firmware.rbh
Source102: dkms-5.6.0.13.tar.gz
Source103: utils-20.20.tar.gz
Source104: firmware-20.20.tar.gz

Patch0: 0001-drm-amd-dkms-use-amdgpu-as-dkms-package-name-to-be-c.patch
# This is commented out as we uncomment it during ROCK DKMS creation
# This should be a temporary measure and will be removed once the kernel is fixed
#Patch1: 0001-drm-amd-Remove-DCN2-and-DCN2.1-from-DKMS-creation.patch

Obsoletes: kernel-debug-devel
%if 0%{?suse_version}
Requires: kernel-syms
%else
Requires: kernel-devel
%endif
Requires: %{name}-firmware = %{epoch}:%{version}-%{release}
Requires(post): %{name}-firmware = %{epoch}:%{version}-%{release}
Requires: gcc, make
Requires: dkms >= 1.95
BuildRequires: autoconf
BuildRequires: automake
BuildRequires: git

Provides: %{module}-kmod = %{version}-%{release}

%description
The AMD display driver kernel module in DKMS format for AMD graphics S/W

%package firmware
Summary: Firmware for %{name}

%description firmware
The AMD display driver firmware blobs used by kernel module in DKMS format

%prep
tar -C %{_sourcedir} -zxvf %{SOURCE102}
tar -C %{_sourcedir} -zxvf %{SOURCE103}
tar -C %{_sourcedir} -zxvf %{SOURCE104}

%{SOURCE1} --prep dkms_uni
%setup -D -T -n linux
pushd %{_sourcedir}/linux
%patch0 -p1
#patch1 -p1
popd

%build
%{SOURCE1} --build dkms_uni

%install
%{SOURCE1} --install dkms_uni

cat << EOF >> %{modsrc}/pre-build.sh

FW_DIR="/lib/firmware/\$KERNELVER"
mkdir -p \$FW_DIR
cp -ar /usr/src/%{module}-%{version}-%{release}/firmware/amdgpu \$FW_DIR
echo "add_drivers+=\" amdgpu \"" >%{dracutd}/%{module}-\$KERNELVER.conf
echo "fw_dir+=\"\$FW_DIR\"" >>%{dracutd}/%{module}-\$KERNELVER.conf
EOF

cat << EOF > %{modsrc}/post-remove.sh
#!/bin/bash

FW_DIR="/lib/firmware"
rm -rf \$FW_DIR/*/amdgpu
[[ ! \$(ls -A \$FW_DIR) ]] && rm -rf \$FW_DIR
rm -f %{dracutd}/%{module}-*.conf
EOF

chmod +x %{modsrc}/post-remove.sh

cat << EOF >> %{modsrc}/dkms.conf
POST_REMOVE="amd/dkms/post-remove.sh \$kernelver"
EOF

mkdir -p %{buildroot}/%{force}
cat << EOF >> %{buildroot}/%{force}/%{module}
%{module}
EOF

%pre
cat << EOF > %{_sysconfdir}/modprobe.d/blacklist-amdgpu.conf
blacklist amdgpu
EOF                                                                              

%post
rc=0
postinst=/usr/lib/dkms/common.postinst

if [ -x $postinst ]; then
  $postinst %{module} %{version}-%{release}
  rc=$?
else
  echo "WARNING: $postinst does not exist."
fi

if [ ! $rc ]; then
  echo -e "ERROR: DKMS version is too old and %{module} was not"
  echo -e "built with legacy DKMS support."
  echo -e "You must either rebuild %{module} with legacy postinst"
  echo -e "support or upgrade DKMS to a more current version."
fi

rm -f %{_sysconfdir}/modprobe.d/blacklist-amdgpu.conf
exit $rc

%preun
dkms remove -m %{module} -v %{version}-%{release} --all --rpm_safe_upgrade
exit $?

%postun
if [ $1 == 0 ]; then
  rm -f %{dracutd}/%{module}-*.conf
fi
exit $?

%clean
rm -rf %{buildroot} %{_builddir}/linux
rm -rf %{_sourcedir}/linux
rm -rf %{_sourcedir}/utils
rm -rf %{_sourcedir}/linux-firmware


%files
%config %{_sysconfdir}/modprobe.d/blacklist-radeon.conf
%config %{_sysconfdir}/udev/rules.d/70-%{module}.rules
/usr/src/%{module}-%{version}-%{release}
%exclude /usr/src/%{module}-%{version}-%{release}/firmware
%dir %{force}
%{force}/%{module}
%{_docdir}/amdgpu-dkms

%files firmware
%license LICENSE.firmware
/usr/src/%{module}-%{version}-%{release}/firmware
%{_docdir}/amdgpu-dkms-firmware


%changelog
* Tue Jun 09 2020 AMD automated build system <gpudriverdevsupport@amd.com> 5.6.0.13-1089974.el8
- linux 
- gerritgit/releases/amd-20.20
- 5148438b41fd31245eda1f2a5fd374ae2f976448
- build ID: 1089974

